import { Connection } from 'typeorm';
import { Factory, Seeder } from 'typeorm-seeding';
import { CreateRunnerOrganisation } from '../models/actions/create/CreateRunnerOrganisation';
import { RunnerOrganisation } from '../models/entities/RunnerOrganisation';

/**
 * Seeds the public runner org (named: "Citizen" by default).
 */
export default class SeedPublicOrg implements Seeder {
    public async run(factory: Factory, connection: Connection): Promise<any> {
        let publicOrg = new CreateRunnerOrganisation();
        publicOrg.name = "Citizen";
        await connection.getRepository(RunnerOrganisation).save(await publicOrg.toEntity());
    }
}